/**
 * @file
 * Update the notification bell badge.
 */

(function ($, Drupal) {
  /**
   * Notification centre bell update behavior.
   */
  Drupal.behaviors.notificationUpdate = {
    attach: function (context) {
      $('.notification-bell', context)
        .once('notificationUpdate')
        .click(this._updateNotificationCount);
    },

    _updateNotificationCount: function () {

      // We won't proceed if the dropdown is already open.
      if ($(this).hasClass('open')) {
        return;
      }

      // Post to the notification endpoint.
      $('.dropdown-menu a', this).first().click();
    }
  };
})(jQuery, Drupal);
